#include "CVehicle.h"

CVehicle::CVehicle(const Ogre::String& name, edge::World* world, edge::Shape* shape,
                float mass, const btVector3& inertia)
: edge::Vehicle(name, world, shape, mass, inertia), mLap(0), mP2Finish(-1.f)
{

}

CVehicle::~CVehicle()
{
    m_world->getPhysicsWorld()->removeRigidBody(m_p);
    //delete m_p;
    m_world->getPhysicsWorld()->removeVehicle(m_vehicle);
    //delete m_vehicle;
    Ogre::SceneManager* smgr = m_g->getCreator();

    //m_world->getActiveSmgr()->destroySceneNode(m_g);
    smgr->destroySceneNode(m_g);
    //m_g->detachAllObjects();
    //m_g->removeAndDestroyAllChildren();
    //smgr->destroySceneNode(m_g);
    Ogre::LogManager::getSingleton().logMessage("LINE "+Ogre::StringConverter::toString(__LINE__));

    for(int i=0; i<m_wheels.size(); i++)
        if(m_wheels[i]->getSceneNode())
        {
            Ogre::LogManager::getSingleton().logMessage("LINE "+Ogre::StringConverter::toString(__LINE__));
            Ogre::SceneNode* sn = m_wheels[i]->getSceneNode();
            //m_world->getActiveSmgr()->destroySceneNode(m_wheels[i]->getSceneNode());
            //smgr->destroySceneNode(m_wheels[i]->getSceneNode());
            //sn->detachAllObjects();
            //sn->removeAndDestroyAllChildren();
            smgr->destroySceneNode(sn);
            Ogre::LogManager::getSingleton().logMessage("LINE "+Ogre::StringConverter::toString(__LINE__));
        }
    Ogre::LogManager::getSingleton().logMessage("LINE "+Ogre::StringConverter::toString(__LINE__));
}

void CVehicle::setSpeedInc(float val)
{
    mSpeedInc = val;
}

float CVehicle::getSpeedInc()
{
    return mSpeedInc;
}

void CVehicle::setMaxSpeed(float val)
{
    mMaxSpeed = val;
}

float CVehicle::getMaxSpeed()
{
    return mMaxSpeed;
}

void CVehicle::setHandling(float val)
{
    mHandling = val;
}

float CVehicle::getHandling()
{
    return mHandling;
}

void CVehicle::setBrakeVal(float val)
{
    mBrake = val;
}

float CVehicle::getBrakeVal()
{
    return mBrake;
}

void CVehicle::setSteerInc(float val)
{
    mSteerInc = val;
}

float CVehicle::getSteerInc()
{
    return mSteerInc;
}

void CVehicle::setMaxSteer(float val)
{
    mMaxSteer = val;
}

float CVehicle::getMaxSteer()
{
    return mMaxSteer;
}
