#ifndef _TRACK_H_
#define _TRACK_H_

#include <Edge.h>

class Track
{
    public:
        Track(edge::Body* body);
        virtual ~Track();

        void addPath(edge::ai::Path* path) { m_path.push_back(path); }
        void setFinishLine(const Ogre::Vector3& pos, float _a, float _b, float _c, float r=20.f);
        float getPointToFinish(const Ogre::Vector3& point);
        bool testDistance(const Ogre::Vector3& pos);

        edge::ai::Path* getPath(int index) { return m_path.at(index); }
        edge::Body* getBody() { return m_body; }

    protected:
        float a;
        float b;
        float c;
        float r;
        Ogre::Vector3 mPos;
        edge::Body* m_body;
        std::vector<edge::ai::Path*> m_path;

};

#endif // _TRACK_H_
