#ifndef _EDGE_VEHICLE_CONTROLLER_H_
#define _EDGE_VEHICLE_CONTROLLER_H_

#include <Controller.h>
#include "CVehicle.h"
#include "Track.h"

class VehicleController : public edge::Controller
{
    public:
        VehicleController(CVehicle* v, Track* track);
        virtual ~VehicleController();

        virtual void update();

        // OIS::KeyListener
        virtual bool keyPressed( const OIS::KeyEvent &arg );
        virtual bool keyReleased( const OIS::KeyEvent &arg );

        // OIS::MouseListener
        virtual bool mouseMoved( const OIS::MouseEvent &arg );
        virtual bool mousePressed( const OIS::MouseEvent &arg, OIS::MouseButtonID id );
        virtual bool mouseReleased( const OIS::MouseEvent &arg, OIS::MouseButtonID id );

    protected:
        void setVehicle(CVehicle* v);
        edge::Vehicle* getVehicle();
        bool m_keyStat[255];

        CVehicle* m_vehicle;
        Track* mTrack;
};

#endif // _EDGE_VEHICLE_CONTROLLER_H_
