#include <Edge.h>
#include "FadeScreenEffect.h"
#include "LangConfig.h"
#include "VehicleController.h"
#include "VehicleAI.h"
#include "CVehicle.h"
#include <SdkTrays.h>
#include "Loader.h"
#include "Track.h"

class EdgeDemo : public EdgeBaseApplication, public Ogre::RenderTargetListener
{
    public :
        enum GAME_STATE { GS_SELECT_LANGUAGE, GS_MAIN_MENU, GS_CHOOSE_VEHICLE, GS_PREPLAYING, GS_PLAYING, GS_PAUSE, GS_OPTIONS, GS_END };

        EdgeDemo();
        ~EdgeDemo();
    protected:
        Ogre::CompositorInstance* mRadialBlur;

        int mCurrentLap;
        int mMaxLap;

        LangConfig* mLang;
        GAME_STATE mGameState;
        Ogre::Camera* m_backCam;
        btClock m_stepTimer;
        std::vector<btVector3> p;
        std::vector<CVehicle*> m_vlist;
        int m_vlistIndex;
        Track* mTrack;
        CVehicle* m_player;
        VehicleController* m_vctrl;

        Ogre::Timer t123;

        OgreBites::Label* mGuiLap;
        OgreBites::Label* mGuiSpeed;
        Ogre::Rectangle2D* m_carMirrorRect;

        Ogre::StringVector mCfgFileList;
        int mCurrentCfgFile;
        CVehicle* mCurrentVehicle;
        int m_vehicleCounter;

        bool mBlurEffect;
        bool mReflectionEffect;

        virtual void playIntro(void);
        virtual void selectLanguage(void);
        virtual void createGameMenu(void);
        virtual void selectVehicle(void);
        virtual void startGame(void);
        virtual void destroyGameScene();
        virtual void guiUpdate(void);
        virtual void createScene(void);
        virtual void createMirror(void);

        virtual void showPauseMenu(void);
        virtual void showOptionsMenu(void);

        virtual bool frameRenderingQueued(const Ogre::FrameEvent& evt);
        virtual bool userFrameRenderingQueued(const Ogre::FrameEvent& evt);
        virtual void preRenderTargetUpdate(const Ogre::RenderTargetEvent& evt);
        virtual void postRenderTargetUpdate(const Ogre::RenderTargetEvent& evt);

        virtual bool keyPressed(const OIS::KeyEvent &arg);
        virtual bool userKeyReleased(const OIS::KeyEvent &arg);

        virtual void buttonHit(OgreBites::Button* button);
		virtual void itemSelected(OgreBites::SelectMenu* menu) {}
		virtual void labelHit(OgreBites::Label* label) {}
		virtual void sliderMoved(OgreBites::Slider* slider) {}
		virtual void checkBoxToggled(OgreBites::CheckBox* box);
		virtual void okDialogClosed(const Ogre::DisplayString& message) {}
		virtual void yesNoDialogClosed(const Ogre::DisplayString& question, bool yesHit) {}

		virtual Ogre::TextAreaOverlayElement* _getButtonTextArea(OgreBites::Button* widget);
		virtual Ogre::TextAreaOverlayElement* _getLabelTextArea(OgreBites::Label* widget);
		virtual Ogre::TextAreaOverlayElement* _getCheckBoxTextArea(OgreBites::CheckBox* widget);
};
